<template>
  <div>
    <el-form ref="arrivalForm" :rules="rules" :model="airArrivalInfo" label-width="120px">
      <!-- <el-form-item :label="$t('预计到港时间')">{{getExpectedTime()}}</el-form-item>
      <el-form-item :label="$t('实际到港时间')" prop="apRealTime">
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="arrivalObj.apRealTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('确认到港')">
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="arrivalObj.apConfirmTime" value-format="yyyy-MM-dd HH:mm:ss">
        </el-date-picker>
        <p class="message-area" v-show="showMsg">{{$t('请确认是否有异常，如有异常请进行异常登记')}}</p>
      </el-form-item> -->
     

      <el-form-item v-if="dtRealHeadTimeFlag" :label="$t('实际二程起飞时间')" prop="actSecondTime">
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="airArrivalInfo.actSecondTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('预计到港时间')" prop="estTime">
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="airArrivalInfo.estTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('实际到港时间')" prop="actTime">
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="airArrivalInfo.actTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>

    </el-form>

    <el-row class="operate-button">
      <el-button type="primary" @click="onSubmit(1)">{{$t('保存')}}</el-button>
      <el-button type="success" @click="onSubmit(2)">{{$t('提交')}}</el-button>
      <el-button @click="cancel">{{$t('关闭')}}</el-button>
      <el-button type="primary" @click="exceptionReg" :disabled="!showMsg">{{$t('异常登记')}}</el-button>
    </el-row>

    <!-- 对话框 -->
    <el-dialog custom-class="shipping-dialog" :title="$t('票异常')" :visible.sync="dialogVisible" width="700px" :modal-append-to-body=false append-to-body destroy-on-close>
      <regError @closeDialog="regCloseDialog" v-bind="$attrs" />
    </el-dialog>
  </div>
</template>

<script>
import regError from "../../regError";
import dayjs from "dayjs";
import { arrivalCreate } from "@/api/ecw/boxSeaAir";
import { formatDateStr, serviceMsg } from "../utils";

/**
 * 到港
 */
export default {
  name: "arrival",
  inheritAttrs: false,
  components: {
    regError,
  },
  data() {
    return {
      // 到港对象
      airArrivalInfo: {},
      // 校验
      rules: {
        actSecondTime: [
          { required: true, message: this.$t("必填"), trigger: "change" },
        ],
        actTime: [
          { required: true, message: this.$t("必填"), trigger: "change" },
        ]
      },
      // 弹窗配置
      dialogVisible: false,
      // 提示消息
      showMsg: false,
      inspectionTimeArrival: this.getDictDatas(
        this.DICT_TYPE.BOX_INSPECTION_TIME_ARRIVAL
      )[0].value,
      dtRealHeadTimeFlag: false
    };
  },
  created() {
    const voName = this.$attrs.currNode.voName;
    let oldData = { ...this.$attrs.shipmentObj[voName] };
    oldData = formatDateStr(
      oldData,
      ["actSecondTime", "estTime", "actTime"],
      "YYYY-MM-DD HH:mm:ss"
    );
    this.airArrivalInfo = oldData;
    if(this.$attrs.shipmentObj['bookAirInfo'].voyage && this.$attrs.shipmentObj['bookAirInfo'].voyage == 2){
      this.dtRealHeadTimeFlag = true
    }
  },
  watch: {
    // 实际二程起飞时间
    "airArrivalInfo.actSecondTime"(val) {
      this.compareDate(this.getHeadTravelTime(), val);
    },

    "airArrivalInfo.estTime"(val) {
      this.compareDate(this.airArrivalInfo.actTime, val);
    },

    "airArrivalInfo.actTime"(val) {
      this.compareDate(this.airArrivalInfo.estTime, val);
    },
  },
  methods: {
    regCloseDialog(type) {
      this.dialogVisible = false;
      if (type === "error") {
        this.$emit("getBoxInfo");
      }
    },
    // 获取预计到港时间
    getHeadTravelTime() {
      const { shippingInfo } = this.$attrs.shipmentObj;
      if (shippingInfo) {
        return dayjs(shippingInfo.realHeadTravelTime).format(
          "YYYY-MM-DD HH:mm:ss"
        );
      }
      return null;
    },
    // 时间比较
    compareDate(expectedTime, apConfirmTime) {
      this.showMsg = false;
      let date1 = null,
        date2 = null;
      if (expectedTime) date1 = dayjs(expectedTime);
      if (apConfirmTime) date2 = dayjs(apConfirmTime);
      if (date1 && date2) {
        const days = date2.diff(date1, "day");
        if (days > this.inspectionTimeArrival) {
          this.showMsg = true;
        }
      }
    },
    // 异常登记
    exceptionReg() {
      this.dialogVisible = true;
    },
    /** 提交 */
    onSubmit(operateType) {
      this.$refs["arrivalForm"].validate((valid) => {
        if (valid) {
          arrivalCreate({
            ...this.airArrivalInfo,
            shipmentId: this.$attrs.shipmentObj.id,
            operateType,
          }).then((res) => {
            serviceMsg(res, this).then(() => {
              this.cancel("submit");
            });
          });
        }
      });
    },
    /** 取消 */
    cancel(type) {
      this.$emit("closeDialog", type);
    },
  },
};
</script>

<style lang="scss" scoped>
.message-area {
  margin: 0;
  color: red;
}
</style>
